Index: /trunk/kernel/devices/dev_ioc.c
===================================================================
--- /trunk/kernel/devices/dev_ioc.c	(revision 656)
+++ /trunk/kernel/devices/dev_ioc.c	(revision 657)
@@ -2,5 +2,5 @@
  * dev_ioc.c - IOC (Block Device Controler) generic device API implementation.
  *
- * Author  Alain Greiner    (2016,2017,2018,2019)
+ * Author  Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -37,6 +37,6 @@
 extern chdev_directory_t  chdev_dir;     // allocated in kernel_init.c
 
-////////////////////////////////////////
-char * dev_ioc_cmd_str( cmd_type_t cmd )
+////////////////////////////////////////////
+char * dev_ioc_cmd_str( ioc_cmd_type_t cmd )
 {
     if     ( cmd == IOC_READ       )  return "READ";
@@ -91,6 +91,44 @@
 }  // end dev_ioc_init()
 
-///////////////////////////////////////////////
-error_t dev_ioc_move_data( uint32_t   cmd_type,
+////////////////////////////////////////////////////////////////////////////////////
+// This static function executes an asynchronous SYNC_READ or SYNC_WRITE request.
+// thread in the IOC device waiting queue, activates the server thread, blocks on 
+// the THREAD_BLOCKED_IO condition and deschedules.
+// The clent is re-activated by the server thread after IO operation completion.
+////////////////////////////////////////////////////////////////////////////////////
+static error_t dev_ioc_move( uint32_t   cmd_type,
+                             xptr_t     buffer_xp,
+                             uint32_t   lba,
+                             uint32_t   count )
+{
+    thread_t * this = CURRENT_THREAD;              // pointer on client thread
+
+    // get extended pointer on IOC chdev descriptor
+    xptr_t      ioc_xp  = chdev_dir.ioc[0];
+
+// check dev_xp
+assert( (ioc_xp != XPTR_NULL) , "undefined IOC chdev descriptor" );
+
+    // register command in client thread  
+    this->ioc_cmd.dev_xp    = ioc_xp;
+    this->ioc_cmd.type      = cmd_type;
+    this->ioc_cmd.buf_xp    = buffer_xp;
+    this->ioc_cmd.lba       = lba;
+    this->ioc_cmd.count     = count;
+
+    // register client thread in IOC queue, blocks and deschedules 
+    chdev_register_command( ioc_xp );
+
+    // return I/O operation status
+    return this->ioc_cmd.error;
+
+}  // end dev_ioc_move()
+
+////////////////////////////////////////////////////////////////////////////////////
+// This static function executes a synchronous READ or WRITE request.
+// It register the command in the client thread descriptor, and calls directly
+// the driver cmd function.
+////////////////////////////////////////////////////////////////////////////////////
+error_t dev_ioc_sync_move( uint32_t   cmd_type,
                            xptr_t     buffer_xp,
                            uint32_t   lba,
@@ -98,21 +136,4 @@
 {
     thread_t * this = CURRENT_THREAD;              // pointer on client thread
-
-#if ( DEBUG_DEV_IOC_RX  || DEBUG_DEV_IOC_TX )
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // software L2/L3 cache coherence for memory buffer
-    if( chdev_dir.iob )
-    {
-        if( (cmd_type == IOC_SYNC_READ) || (cmd_type == IOC_READ) )
-        {
-            dev_mmc_inval( buffer_xp , count<<9 );
-        }
-        else  // (cmd_type == IOC_SYNC_WRITE) or (cmd_type == IOC_WRITE)
-        {
-            dev_mmc_sync ( buffer_xp , count<<9 );
-        }
-    }
 
     // get extended pointer on IOC chdev descriptor
@@ -129,85 +150,153 @@
     this->ioc_cmd.count     = count;
 
-    // for a synchronous acces, the driver is directly called by the client thread 
-    if( (cmd_type == IOC_SYNC_READ) || (cmd_type == IOC_SYNC_WRITE) )
-    {
-
-#if DEBUG_DEV_IOC_RX
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-if( (DEBUG_DEV_IOC_RX < cycle) && (cmd_type == IOC_SYNC_READ) )
-printk("\n[%s] thread[%x,%x] enters for SYNC_READ / lba  %x / buffer[%x,%x] / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, lba,
-GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
-#endif
-
-#if DEBUG_DEV_IOC_TX
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-if( (DEBUG_DEV_IOC_TX < cycle) && (cmd_type == IOC_SYNC_WRITE) )
-printk("\n[%s] thread[%x,%x] enters for SYNC_WRITE / lba  %x / buffer[%x,%x] / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, lba,
-GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
-#endif
-        // get driver command function
-        cxy_t       ioc_cxy = GET_CXY( ioc_xp );
-        chdev_t   * ioc_ptr = GET_PTR( ioc_xp );
-        dev_cmd_t * cmd = (dev_cmd_t *)hal_remote_lpt( XPTR( ioc_cxy , &ioc_ptr->cmd ) );
-
-        // call driver function
-        cmd( XPTR( local_cxy , this ) );
-
-#if DEBUG_DEV_IOC_RX
-if( (DEBUG_DEV_IOC_RX < cycle) && (cmd_type == IOC_SYNC_READ) )
-printk("\n[%s] thread[%x,%x] resumes for IOC_SYNC_READ\n",
-__FUNCTION__, this->process->pid , this->trdid )
-#endif
-
-#if DEBUG_DEV_IOC_TX
-if( (DEBUG_DEV_IOC_RX < cycle) && (cmd_type == IOC_SYNC_WRITE) )
-printk("\n[%s] thread[%x,%x] resumes for IOC_SYNC_WRITE\n",
-__FUNCTION__, this->process->pid , this->trdid )
-#endif
-
-    }
-    // for an asynchronous access, the client thread registers in the chdev waiting queue,
-    // activates server thread, blocks on THREAD_BLOCKED_IO and deschedules.
-    // It is re-activated by the server thread after IO operation completion.
-    else  // (cmd_type == IOC_READ) || (cmd_type == IOC_WRITE)
-    {
-
-#if DEBUG_DEV_IOC_RX
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-if( (DEBUG_DEV_IOC_RX < cycle) && (cmd_type == IOC_READ) )
-printk("\n[%s] thread[%x,%x] enters for READ / lba  %x / buffer[%x,%x] / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, lba,
-GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
-#endif
-
-#if DEBUG_DEV_IOC_TX
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-if( (DEBUG_DEV_IOC_TX < cycle) && (cmd_type == IOC_WRITE) )
-printk("\n[%s] thread[%x,%x] enters for WRITE / lba  %x / buffer[%x,%x] / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, lba,
-GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
-#endif
-        chdev_register_command( ioc_xp );
-
-#if(DEBUG_DEV_IOC_RX )
-if( (DEBUG_DEV_IOC_RX < cycle) && (cmd_type == IOC_READ) )
-printk("\n[%s] thread[%x,%x] resumes for IOC_READ\n",
-__FUNCTION__, this->process->pid , this->trdid )
-#endif
-
-#if(DEBUG_DEV_IOC_TX & 1)
-if( (DEBUG_DEV_IOC_RX < cycle) && (cmd_type == IOC_WRITE) )
-printk("\n[%s] thread[%x,%x] resumes for IOC_WRITE\n",
-__FUNCTION__, this->process->pid , this->trdid )
-#endif
-
-    }
+    // get driver command function
+    cxy_t       ioc_cxy = GET_CXY( ioc_xp );
+    chdev_t   * ioc_ptr = GET_PTR( ioc_xp );
+    dev_cmd_t * cmd = (dev_cmd_t *)hal_remote_lpt( XPTR( ioc_cxy , &ioc_ptr->cmd ) );
+
+    // call driver function whithout blocking & descheduling
+    cmd( XPTR( local_cxy , this ) );
 
     // return I/O operation status
     return this->ioc_cmd.error;
 
-}  // end dev_ioc_move_data()
-
-
+}  // end dev_ioc_sync_move()
+
+///////////////////////////////////////////
+error_t dev_ioc_read( xptr_t     buffer_xp,
+                      uint32_t   lba,
+                      uint32_t   count )
+{
+
+#if DEBUG_DEV_IOC_RX
+thread_t * this  = CURRENT_THREAD;
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_RX < cycle )
+printk("\n[%s] thread[%x,%x] enters IOC_READ / lba  %x / buffer[%x,%x] / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, lba,
+GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
+#endif
+
+    // software L2/L3 cache coherence for memory buffer
+    if( chdev_dir.iob ) dev_mmc_inval( buffer_xp , count<<9 );
+
+    // request an asynchronous transfer
+    error_t error = dev_ioc_move( IOC_READ,
+                                  buffer_xp,
+                                  lba,
+                                  count );
+#if(DEBUG_DEV_IOC_RX & 1)
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_RX < cycle )
+printk("\n[%s] thread[%x,%x] exit IOC_READ / cycle %d\n",
+__FUNCTION__, this->process->pid , this->trdid , cycle );
+#endif
+
+    return error;
+
+}  // end dev_ioc_read()
+
+///////////////////////////////////////////
+error_t dev_ioc_write( xptr_t     buffer_xp,
+                       uint32_t   lba,
+                       uint32_t   count )
+{
+
+#if DEBUG_DEV_IOC_TX
+thread_t * this  = CURRENT_THREAD;
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_TX < cycle )
+printk("\n[%s] thread[%x,%x] enters IOC_WRITE / lba  %x / buffer[%x,%x] / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, lba,
+GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
+#endif
+
+    // software L2/L3 cache coherence for memory buffer
+    if( chdev_dir.iob ) dev_mmc_sync ( buffer_xp , count<<9 );
+
+    // request a blocking, but asynchronous, transfer
+    error_t error = dev_ioc_move( IOC_WRITE,
+                          buffer_xp,
+                          lba,
+                          count );
+#if(DEBUG_DEV_IOC_TX & 1)
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_TX < cycle )
+printk("\n[%s] thread[%x,%x] exit IOC_WRITE / cycle %d\n",
+__FUNCTION__, this->process->pid , this->trdid , cycle );
+#endif
+
+    return error;
+
+}  // end dev_ioc_write()
+
+
+///////////////////////////////////////////
+error_t dev_ioc_sync_read( xptr_t     buffer_xp,
+                           uint32_t   lba,
+                           uint32_t   count )
+{
+
+#if DEBUG_DEV_IOC_RX
+thread_t * this  = CURRENT_THREAD;
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_RX < cycle )
+printk("\n[%s] thread[%x,%x] enters IOC_SYNC_READ / lba  %x / buffer[%x,%x] / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, lba,
+GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
+#endif
+
+    // software L2/L3 cache coherence for memory buffer
+    if( chdev_dir.iob ) dev_mmc_inval( buffer_xp , count<<9 );
+
+    // request an asynchronous transfer
+    error_t error = dev_ioc_sync_move( IOC_SYNC_READ,
+                                       buffer_xp,
+                                       lba,
+                                       count );
+#if(DEBUG_DEV_IOC_RX & 1)
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_RX < cycle )
+printk("\n[%s] thread[%x,%x] exit IOC_SYNC_READ / cycle %d\n",
+__FUNCTION__, this->process->pid , this->trdid , cycle );
+#endif
+
+    return error;
+
+}  // end dev_ioc_sync_read()  
+
+/////////////////////////////////////////////////
+error_t dev_ioc_sync_write( xptr_t     buffer_xp,
+                            uint32_t   lba,
+                            uint32_t   count )
+{
+
+#if DEBUG_DEV_IOC_TX
+thread_t * this  = CURRENT_THREAD;
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_TX < cycle )
+printk("\n[%s] thread[%x,%x] enters IOC_SYNC_WRITE / lba  %x / buffer[%x,%x] / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, lba,
+GET_CXY(buffer_xp), GET_PTR(buffer_xp), cycle );
+#endif
+
+    // software L2/L3 cache coherence for memory buffer
+    if( chdev_dir.iob ) dev_mmc_sync ( buffer_xp , count<<9 );
+
+    // request a blocking, but asynchronous, transfer
+    error_t error = dev_ioc_sync_move( IOC_SYNC_WRITE,
+                                       buffer_xp,
+                                       lba,
+                                       count );
+#if(DEBUG_DEV_IOC_TX & 1)
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_IOC_TX < cycle )
+printk("\n[%s] thread[%x,%x] exit IOC_SYNC_WRITE / cycle %d\n",
+__FUNCTION__, this->process->pid , this->trdid , cycle );
+#endif
+
+    return error;
+
+}  // end dev_ioc_sync_write() 
+
+
Index: /trunk/kernel/devices/dev_ioc.h
===================================================================
--- /trunk/kernel/devices/dev_ioc.h	(revision 656)
+++ /trunk/kernel/devices/dev_ioc.h	(revision 657)
@@ -2,5 +2,5 @@
  * dev_ioc.h - IOC (Block Device Controler) generic device API definition.
  * 
- * Author  Alain Greiner    (2016,2017,2018,2019)
+ * Author  Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -45,5 +45,5 @@
  * - SYNC_WRITE : move blocks from memory to device, with a busy waiting policy.
  *
- * For the he READ or WRITE operations, the client thread is descheduled, and the work
+ * For the READ or WRITE operations, the client thread is descheduled, and the work
  * is done by the server thread associated to the IOC device:
  * The client thread calls the dev_ioc_move_data() kernel functions that (i) registers
@@ -93,5 +93,5 @@
 
 /******************************************************************************************
- * This defines the (implementation independant)  command passed to the driver.
+ * This structure defines the IOC command for all drivers implementing the IOC device.
  *****************************************************************************************/
 
@@ -103,5 +103,5 @@
     IOC_SYNC_WRITE = 3,
 }
-cmd_type_t;
+ioc_cmd_type_t;
 
 typedef struct ioc_command_s
@@ -111,5 +111,5 @@
     uint32_t    lba;        /*! first block index                                        */
     uint32_t    count;      /*! number of blocks                                         */
-    xptr_t      buf_xp;     /*! extended pointer on memory buffer                        */
+    xptr_t      buf_xp;     /*! extended pointer on kernel memory buffer                 */
     uint32_t    error;      /*! operation status (0 if success)                          */
 }
@@ -122,5 +122,5 @@
  * @ return pointer on string.
  *****************************************************************************************/
-char * dev_ioc_cmd_str( cmd_type_t cmd );
+char * dev_ioc_cmd_str( ioc_cmd_type_t cmd );
 
 /******************************************************************************************
@@ -138,23 +138,74 @@
 
 /******************************************************************************************
- * This blocking function moves <count> contiguous blocks of data between the block device
- * starting from block defined by the <lba> argument and a kernel memory buffer, defined
- * by the <buffer_xp> argument. The transfer direction and mode are defined by the 
- * <cmd_type> argument. The request is always registered in the calling thread descriptor.
- * - In synchronous mode, the calling thread is not descheduled, and directly calls the
- *   IOC driver, polling the IOC status to detect transfer completion.
- * - In asynchronous mode, the calling thread blocks and deschedules, and the IOC driver
- *   is called by the server thread associated to the IOC device.
- ******************************************************************************************
- * @ cmd_type  : IOC_READ / IOC_WRITE / IOC_SYNC_READ / IOC_SYN_WRITE.
- * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
- * @ lba       : first block index on device.
- * @ count     : number of blocks to transfer.
- * @ returns 0 if success / returns -1 if error.
- *****************************************************************************************/
-error_t dev_ioc_move_data( uint32_t  cmd_type,
-                           xptr_t    buffer_xp,
+ * This blocking function register an asynchronous READ request : move <count> contiguous
+ * blocks from the block device, starting from block defined by the <lba> argument, to a
+ * kernel buffer defined by the <buffer_xp> argument.
+ * It register the request in the client thread descriptor, it register the client thread
+ * in the IOC device queue, it blocks on the THREAD_BLOCKED_IO condition, and deschedules.
+ * It will be reactivated by the DEV server thread when the transfer is completed.
+ * It can be executed by a thread running in any cluster.
+ ******************************************************************************************
+ * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
+ * @ lba       : first block index on device.
+ * @ count     : number of blocks to transfer.
+ * @ returns 0 if success / returns -1 if error.
+ *****************************************************************************************/
+error_t dev_ioc_read( xptr_t    buffer_xp,
+                      uint32_t  lba,
+                      uint32_t  count );
+
+/******************************************************************************************
+ * This blocking function register an asynchronous WRITE request : move <count> contiguous
+ * blocks from a kernel buffer defined by the <buffer_xp> argument to the block device,
+ * starting from block defined by the <lba> argument.
+ * It register the request in the client thread descriptor, it register the client thread
+ * in the IOC device queue, it blocks on the THREAD_BLOCKED_IO condition, and deschedules.
+ * It will be reactivated by the DEV server thread when the transfer is completed.
+ * It can be executed by a thread running in any cluster.
+ ******************************************************************************************
+ * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
+ * @ lba       : first block index on device.
+ * @ count     : number of blocks to transfer.
+ * @ returns 0 if success / returns -1 if error.
+ *****************************************************************************************/
+error_t dev_ioc_write( xptr_t    buffer_xp,
+                       uint32_t  lba,
+                       uint32_t  count );
+
+/******************************************************************************************
+ * This blocking function executes a synchronous SYNC_READ request : it moves <count>
+ * contiguous blocks of data from the block device, starting from block defined by the
+ * <lba> argument to a kernel memory buffer, defined by the <buffer_xp> argument. 
+ * The request is registered in the calling thread descriptor, but the client thread calls
+ * directly the driver cmd function, that is also a blocking function returning only
+ * when the transfer is completed.
+ * It can be executed by a thread running in any cluster.
+ ******************************************************************************************
+ * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
+ * @ lba       : first block index on device.
+ * @ count     : number of blocks to transfer.
+ * @ returns 0 if success / returns -1 if error.
+ *****************************************************************************************/
+error_t dev_ioc_sync_read( xptr_t    buffer_xp,
                            uint32_t  lba,
                            uint32_t  count );
 
+/******************************************************************************************
+ * This blocking function executes a synchronous SYNC_WRITE request : it moves <count>
+ * contiguous blocks of data from a kernel memory buffer, defined by the <buffer_xp>
+ * argument to the block device, starting from block defined by the <lba> argument. 
+ * The request is registered in the calling thread descriptor, but the client thread calls
+ * directly the driver cmd() function, that is also a blocking function returning only
+ * when the transfer is completed.
+ * It can be executed by a thread running in any cluster.
+ ******************************************************************************************
+ * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
+ * @ lba       : first block index on device.
+ * @ count     : number of blocks to transfer.
+ * @ returns 0 if success / returns -1 if error.
+ *****************************************************************************************/
+error_t dev_ioc_sync_write( xptr_t    buffer_xp,
+                            uint32_t  lba,
+                            uint32_t  count );
+
 #endif	/* _DEV_IOC_H */
Index: /trunk/kernel/devices/dev_mmc.c
===================================================================
--- /trunk/kernel/devices/dev_mmc.c	(revision 656)
+++ /trunk/kernel/devices/dev_mmc.c	(revision 657)
@@ -2,5 +2,5 @@
  * dev_mmc.c - MMC (Memory Cache Controler) generic device API implementation.
  * 
- * Author  Alain Greiner    (2016,2017,2018)
+ * Author  Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -176,5 +176,5 @@
 
 /////////////////////////////////////////
-error_t dev_mmc_set_error( cxy_t     cxy,
+error_t dev_mmc_error_set( cxy_t     cxy,
                            uint32_t  index,
                            uint32_t  wdata )
@@ -185,5 +185,5 @@
     // store command arguments in thread descriptor
     this->mmc_cmd.dev_xp    = chdev_dir.mmc[cxy];
-    this->mmc_cmd.type      = MMC_SET_ERROR;
+    this->mmc_cmd.type      = MMC_ERROR_SET;
     this->mmc_cmd.reg_index = index;
     this->mmc_cmd.reg_ptr   = &wdata;
@@ -194,5 +194,5 @@
                         
 //////////////////////////////////////////
-error_t dev_mmc_get_error( cxy_t      cxy,
+error_t dev_mmc_error_get( cxy_t      cxy,
                            uint32_t   index,
                            uint32_t * rdata )
@@ -203,5 +203,5 @@
     // store command arguments in thread descriptor
     this->mmc_cmd.dev_xp    = chdev_dir.mmc[cxy];
-    this->mmc_cmd.type      = MMC_GET_ERROR;
+    this->mmc_cmd.type      = MMC_ERROR_GET;
     this->mmc_cmd.reg_index = index;
     this->mmc_cmd.reg_ptr   = rdata;
@@ -210,9 +210,9 @@
     return dev_mmc_access( this ); 
 }
-                        
-////////////////////////////////////////////////////
-error_t dev_mmc_get_instrumentation( cxy_t      cxy,
-                                     uint32_t   index,
-                                     uint32_t * rdata )
+
+//////////////////////////////////////////
+error_t dev_mmc_instr_get( cxy_t      cxy,
+                           uint32_t   index,
+                           uint32_t * rdata )
 {
     // get calling thread local pointer
@@ -221,5 +221,5 @@
     // store command arguments in thread descriptor
     this->mmc_cmd.dev_xp    = chdev_dir.mmc[cxy];
-    this->mmc_cmd.type      = MMC_GET_INSTRU;
+    this->mmc_cmd.type      = MMC_INSTR_GET;
     this->mmc_cmd.reg_index = index;
     this->mmc_cmd.reg_ptr   = rdata;
@@ -228,3 +228,2 @@
     return dev_mmc_access( this ); 
 }
-
Index: /trunk/kernel/devices/dev_mmc.h
===================================================================
--- /trunk/kernel/devices/dev_mmc.h	(revision 656)
+++ /trunk/kernel/devices/dev_mmc.h	(revision 657)
@@ -2,5 +2,5 @@
  * dev_mmc.h - MMC (Generic L2 cache controller) device API definition.
  *
- * Authors   Alain Greiner  (2016,2017,2018)
+ * Authors   Alain Greiner  (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -34,10 +34,15 @@
  * acting in all clusters containing a level 2 cache controller.
  *
- * It supports  five command types: 
+ * It supports three different services:
+ * 1) L2/L3 software cache-coherence operations.
+ * 2) error reporting for architecture specific addressing error.
+ * 3) architecture specific intrumentation registers access. 
+ *
+ * It supports therefore five command types: 
  * - MMC_CC_INVAL   : invalidate all cache lines covering a given buffer in L2 cache.
  * - MMC_CC_SYNC    : synchronize all cache lines covering a given buffer to L3 cache.
- * - MMC_GET_ERROR  : return content of a given error signaling register.
- * - MMC_SET_ERROR  : set a given error signaling register.
- * - MMC_GET_INSTRU : return content of a given instrumentation register.
+ * - MMC_ERROR_GET  : return content of a given error signaling register.
+ * - MMC_ERROR_SET  : set a given error signaling register.
+ * - MMC_INSTR_GET  : return content of a given instrumentation register.
  *
  * As all L2 caches can be accessed by any thread running in any cluster, a calling
@@ -73,7 +78,7 @@
     MMC_CC_INVAL   = 0,
     MMC_CC_SYNC    = 1,
-    MMC_GET_ERROR  = 2,
-    MMC_SET_ERROR  = 3,
-    MMC_GET_INSTRU = 4,
+    MMC_ERROR_GET  = 2,
+    MMC_ERROR_SET  = 3,
+    MMC_INSTR_GET  = 4,
 };
 
@@ -126,5 +131,5 @@
                         
 /*****************************************************************************************
- * This function set a value in one error signaling MMC register.
+ * This function set a value in one (architecture specific) MMC_ERROR register.
  * It can be executed by any thread in any cluster, because it uses remote accesses
  * to access the L2 cache instrumentation interface in any cluster.
@@ -135,12 +140,12 @@
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_set_error( cxy_t    cxy,
+error_t dev_mmc_error_set( cxy_t    cxy,
                            uint32_t index,
                            uint32_t wdata );
               
 /*****************************************************************************************
- * This function returns the value contained in one error signaling MMC register.
- * It can be executed by any thread in any cluster, because it uses remote accesses
- * to access the L2 cache instrumentation interface in any cluster.
+ * This function returns the value contained in one (architecture specific) MMC_ERROR
+ * register. It can be executed by any thread in any cluster, because it uses remote
+ * accesses to access the L2 cache instrumentation interface in any cluster.
  *****************************************************************************************
  * @ cxy     : MMC cluster identifier.
@@ -149,22 +154,21 @@
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_get_error( cxy_t      cxy,
+error_t dev_mmc_error_get( cxy_t      cxy,
                            uint32_t   index, 
                            uint32_t * rdata );
               
-
 /*****************************************************************************************
- * This function returns the value contained in one instrumentation MMC register.
- * It can be executed by any thread in any cluster, because it uses remote accesses
- * to access the L2 cache configuration interface in any cluster.
+ * This function returns the value contained in one (architecture specific) MMC_INSTR
+ * register. It can be executed by any thread in any cluster, because it uses remote
+ * accesses to access the L2 cache instrumentation interface in any cluster.
  *****************************************************************************************
  * @ cxy     : MMC cluster identifier.
- * @ index   : instrumentation register index in MMC peripheral.
+ * @ index   : error register index in MMC peripheral.
  * @ rdata   : local pointer on buffer for returned value.
  * @ return 0 if success / return EINVAL if failure
  ****************************************************************************************/
-error_t dev_mmc_get_instrumentation( cxy_t      cxy,
-                                     uint32_t   index,
-                                     uint32_t * rdata );
-
+error_t dev_mmc_instr_get( cxy_t      cxy,
+                           uint32_t   index, 
+                           uint32_t * rdata );
+              
 #endif  /* _DEV_MMC_H_ */
